
  <!DOCTYPE html>
  <html>
    <head>
      <title>FloatInput.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/components/FloatInput/FloatInput.tsx</td><td class="">100.00%</td><td class="">80%</td><td class="">106</td><td class="">106</td><td class="">0</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useEffect, useRef, useState } from &#x27;react&#x27;;
import { Input, InputProps } from &#x27;../Input/Input&#x27;;

export interface FloatTextInputProps
  extends Omit&lt;InputProps, &#x27;value&#x27; | &#x27;onChange&#x27;&gt; {
  value?: number;
  onChange?: (value?: number) =&gt; void;
  min?: number;
  max?: number;
  error?: string;
}
export const FloatTextInput: React.FC&lt;FloatTextInputProps&gt; = ({
  value,
  onChange,
  min,
  max,
  error,
  ...props
}) =&gt; {
  const [innerValue, setInnerValue] = useState(&#x27;&#x27;);
  // const [error,  setError] = useState(&#x27;&#x27;);
  const [isFocused, setFocused] = useState(false);
  const focusedRef = useRef(isFocused);
  useEffect(() =&gt; {
    focusedRef.current = isFocused;
  }, [isFocused]);
  useEffect(() =&gt; {
    if (
      typeof value === &#x27;number&#x27; &amp;&amp;
      value.toString() !== parseFloat(innerValue).toString()
    ) {
      if (typeof value === &#x27;number&#x27; &amp;&amp; focusedRef.current &amp;&amp; value === 0) {
        setInnerValue(&#x27;&#x27;);
      } else if (!innerValue) {
        setInnerValue(value.toString());
      }
    }
  }, [innerValue, value]);
  const innerOnChange = useCallback(
    (event: React.ChangeEvent&lt;HTMLInputElement&gt;) =&gt; {
      const value = event.target.value;

      if (value === &#x27;&#x27;) {
        setInnerValue(&#x27;&#x27;);
        if (onChange) onChange(undefined);
        return;
      }
      // eslint-disable-next-line
      if (!/^[0-9]{1,}(\.|\,){0,1}[0-9]{0,}$/.test(value)) {
        return;
      }
      setInnerValue(value);
      const valueWithUnifiedDelimiter = value.replace(/,/g, &#x27;.&#x27;);

      const parsedValue = parseFloat(valueWithUnifiedDelimiter);
      if (isFinite(parsedValue)) {
        if (min &amp;&amp; parsedValue &lt; min) {
          // setError(&#x27;The value is less than the allowed value&#x27;);
        } else if (max &amp;&amp; parsedValue &gt; max) {
          // setError(&#x27;The value is greater than the allowed value&#x27;);
        } else {
          // setError(&#x27;&#x27;);
        }
        if (onChange) onChange(parsedValue);
      }
    },
    [onChange, max, min]
  );
  return (
    &lt;Input
      onFocus={() =&gt; setFocused(true)}
      onBlur={() =&gt; setFocused(false)}
      value={innerValue}
      onChange={innerOnChange}
      error={error}
      {...props}
    /&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  